// ExampleCommandRouter.java
//
// Informatics 102 Spring 2012
// Code Example
//
// This class implements only a small slice of the problem: it takes a
// command byte and a byte[] containing the command's parameter(s) and
// routes the command to the appropriate command handler.  This is really
// all the behavior we describe in a Q script, so we've separated
// into its own class.
//
// Interestingly, this design appears to be likely to give us what we
// want: it has a regular, repeating pattern that we could use in our
// compiler.  We could write a compiler that takes an Q script and
// generates exactly this (comments and all)!

package inf102.q.example;


public class ExampleCommandRouter implements CommandRouter
{
	public byte[] routeCommand(int commandByte, byte[] parameterBytes)
	{
		switch (commandByte)
		{
		case 1:		// Square
			return new SquareCommandHandler().handleCommand(parameterBytes);
			
		case 2:		// Cube
			return new CubeCommandHandler().handleCommand(parameterBytes);
			
		default:
			return new byte[0];	
		}
	}
}
