// QCompiler.java
//
// Informatics 102 Spring 2012
// Code Example
//
// This is a Q compiler.  It takes a command-line argument specifying
// the name of an Q script to be compiled, then compiles it to a .java
// file.

package inf102.q.compiler;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;


public class QCompiler
{
	public static void main(String[] args)
	{
		if (args.length != 1)
		{
			printUsageMessage();
			return;
		}
		
		try (FileReader inputFile = new FileReader(args[0]))
		{
			QScript script = new QParser(new QScanner(inputFile)).parse();
			
			String generatedCode = new QCodeGenerator().generateCode(script);

			try (PrintWriter outputFile = new PrintWriter(
					new FileWriter(script.getRouterName() + "CommandRouter.java")))
			{
				outputFile.print(generatedCode);
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
	private static void printUsageMessage()
	{
		System.out.println("USAGE: java QCompiler Q_SCRIPT_NAME");
	}
}
