// QScript.java
//
// Informatics 102 Spring 2012
// Code Example
//
// A QScript object encapsulates everything interesting about a
// Q script; in other words, it holds all of the information that
// the compiler will need, after parsing the script, in order to generate
// code from it.
//
// What we need to know is the "router name" (the identifier that follows
// the word "router" in the script), as well as the commands listed within
// it.

package inf102.q.compiler;

import java.util.ArrayList;


public class QScript
{
	private String routerName;
	private ArrayList<QCommand> commands;
	
	
	public QScript(String routerName, ArrayList<QCommand> commands)
	{
		this.routerName = routerName;
		this.commands = commands;
	}
	
	
	public String getRouterName()
	{
		return routerName;
	}
	

	public ArrayList<QCommand> getCommands()
	{
		return commands;
	}
}
