// PacketHandler.java
//
// Informatics 102 Spring 2012
// Code Example
//
// PacketHandlers read and react to individual packets sent from an Erlang
// program.  The assumption is that each packet contains a single byte
// specifying its length, followed by a single command byte, followed by the
// remaining bytes that comprise the parameter(s) to the command.
//
// PacketHandlers read the packet but don't act on it; instead, they pass
// most of the work on to a CommandRouter, who, in turn, passes it to the
// appropriate CommandHandler.  Then, when the command returns its result,
// the PacketHandler writes the response back to the Erlang program.

package inf102.q.lib;


public class PacketHandler
{
	public void run(CommandRouter commandRouter)
	{
		try
		{
			while (true)
			{
				int lengthByte = System.in.read();
				
				if (lengthByte == -1)
				{
					return;
				}
				
				int commandByte = System.in.read();
				byte[] parameterBytes = new byte[lengthByte - 1];
				
				for (int i = 0; i < parameterBytes.length; i++)
				{
					parameterBytes[i] = (byte) System.in.read();
				}
				
				byte[] resultBytes = commandRouter.routeCommand(
					commandByte, parameterBytes);
				
				System.out.write((byte) resultBytes.length);
				
				for (int i = 0; i < resultBytes.length; i++)
				{
					System.out.write(resultBytes[i]);
				}
				
				System.out.flush();
			}
		}
		catch (Exception e)
		{
		}
	}
}
